// Code generated by goa v3.6.0, DO NOT EDIT.
//
// Service1 HTTP client types
//
// Command:
// $ goa gen goa_example/design

package client

import (
	service1 "goa_example/gen/service1"

	goa "goa.design/goa/v3/pkg"
)

// SecureRequestBody is the type of the "Service1" service "secure" endpoint
// HTTP request body.
type SecureRequestBody struct {
	// Whether to force auth failure even with a valid JWT
	Fail *bool `form:"fail,omitempty" json:"fail,omitempty" xml:"fail,omitempty"`
}

// SigninOKResponseBody is the type of the "Service1" service "signin" endpoint
// HTTP response body.
type SigninOKResponseBody struct {
	// JWT token
	JWT *string `form:"jwt,omitempty" json:"jwt,omitempty" xml:"jwt,omitempty"`
	// API Key
	APIKey *string `form:"api_key,omitempty" json:"api_key,omitempty" xml:"api_key,omitempty"`
	// OAuth2 token
	OauthToken *string `form:"oauth_token,omitempty" json:"oauth_token,omitempty" xml:"oauth_token,omitempty"`
}

// SigninBadRequestResponseBody is used to define fields on response body types.
type SigninBadRequestResponseBody struct {
	// JWT token
	JWT *string `form:"jwt,omitempty" json:"jwt,omitempty" xml:"jwt,omitempty"`
	// API Key
	APIKey *string `form:"api_key,omitempty" json:"api_key,omitempty" xml:"api_key,omitempty"`
	// OAuth2 token
	OauthToken *string `form:"oauth_token,omitempty" json:"oauth_token,omitempty" xml:"oauth_token,omitempty"`
}

// NewSecureRequestBody builds the HTTP request body from the payload of the
// "secure" endpoint of the "Service1" service.
func NewSecureRequestBody(p *service1.SecurePayload) *SecureRequestBody {
	body := &SecureRequestBody{
		Fail: p.Fail,
	}
	return body
}

// NewSigninCredsOK builds a "Service1" service "signin" endpoint result from a
// HTTP "OK" response.
func NewSigninCredsOK(body *SigninOKResponseBody) *service1.Creds {
	v := &service1.Creds{
		JWT:        *body.JWT,
		APIKey:     *body.APIKey,
		OauthToken: *body.OauthToken,
	}

	return v
}

// NewSigninUnauthorized builds a Service1 service signin endpoint unauthorized
// error.
func NewSigninUnauthorized(body string) service1.Unauthorized {
	v := service1.Unauthorized(body)

	return v
}

// NewSecureUnauthorized builds a Service1 service secure endpoint unauthorized
// error.
func NewSecureUnauthorized(body string) service1.Unauthorized {
	v := service1.Unauthorized(body)

	return v
}

// ValidateSigninOKResponseBody runs the validations defined on
// SigninOKResponseBody
func ValidateSigninOKResponseBody(body *SigninOKResponseBody) (err error) {
	if body.JWT == nil {
		err = goa.MergeErrors(err, goa.MissingFieldError("jwt", "body"))
	}
	if body.APIKey == nil {
		err = goa.MergeErrors(err, goa.MissingFieldError("api_key", "body"))
	}
	if body.OauthToken == nil {
		err = goa.MergeErrors(err, goa.MissingFieldError("oauth_token", "body"))
	}
	return
}

// ValidateSigninBadRequestResponseBody runs the validations defined on
// SigninBad RequestResponseBody
func ValidateSigninBadRequestResponseBody(body *SigninBadRequestResponseBody) (err error) {
	if body.JWT == nil {
		err = goa.MergeErrors(err, goa.MissingFieldError("jwt", "body"))
	}
	if body.APIKey == nil {
		err = goa.MergeErrors(err, goa.MissingFieldError("api_key", "body"))
	}
	if body.OauthToken == nil {
		err = goa.MergeErrors(err, goa.MissingFieldError("oauth_token", "body"))
	}
	return
}
